require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_HIGHMEM_H)) {
    eval 'sub _ASM_HIGHMEM_H () {1;}' unless defined(&_ASM_HIGHMEM_H);
    if(defined(&__KERNEL__)) {
	require 'linux/interrupt.ph';
	require 'asm/kmap_types.ph';
	eval 'sub HIGHMEM_DEBUG () {1;}' unless defined(&HIGHMEM_DEBUG);
	eval 'sub LAST_PKMAP () {1024;}' unless defined(&LAST_PKMAP);
	eval 'sub LAST_PKMAP_MASK () {( &LAST_PKMAP - 1);}' unless defined(&LAST_PKMAP_MASK);
	eval 'sub PKMAP_NR {
	    local($virt) = @_;
    	    eval q((($virt -  &pkmap_base) >>  &PAGE_SHIFT));
	}' unless defined(&PKMAP_NR);
	eval 'sub PKMAP_ADDR {
	    local($nr) = @_;
    	    eval q(( &pkmap_base + (($nr) <<  &PAGE_SHIFT)));
	}' unless defined(&PKMAP_ADDR);
	eval 'sub kmap {
	    local($page) = @_;
    	    eval q( &__kmap($page, 0));
	}' unless defined(&kmap);
	eval 'sub kmap_nonblock {
	    local($page) = @_;
    	    eval q( &__kmap($page, 1));
	}' unless defined(&kmap_nonblock);
	eval 'sub void {
	    eval q(* &__kmap(\'struct page\' * &page, \'int\'  &nonblocking) {  &if ( &in_interrupt())  &BUG();  &if ( &page <  &highmem_start_page)  &page_address( &page);  &kmap_high( &page,  &nonblocking); });
	}' unless defined(&void);
	eval 'sub kunmap {
	    local($page) = @_;
    	    eval q({  &if ( &in_interrupt())  &BUG();  &if ($page <  &highmem_start_page) ;  &kunmap_high($page); });
	}' unless defined(&kunmap);
    }
}
1;
