require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_PGTSUN4C_H)) {
    eval 'sub _SPARC_PGTSUN4C_H () {1;}' unless defined(&_SPARC_PGTSUN4C_H);
    require 'asm/contregs.ph';
    eval 'sub SUN4C_PMD_SHIFT () {22;}' unless defined(&SUN4C_PMD_SHIFT);
    eval 'sub SUN4C_PMD_SIZE () {(1 <<  &SUN4C_PMD_SHIFT);}' unless defined(&SUN4C_PMD_SIZE);
    eval 'sub SUN4C_PMD_MASK () {(~( &SUN4C_PMD_SIZE-1));}' unless defined(&SUN4C_PMD_MASK);
    eval 'sub SUN4C_PMD_ALIGN {
        local($addr) = @_;
	    eval q(((($addr)+ &SUN4C_PMD_SIZE-1) &SUN4C_PMD_MASK));
    }' unless defined(&SUN4C_PMD_ALIGN);
    eval 'sub SUN4C_PGDIR_SHIFT () {22;}' unless defined(&SUN4C_PGDIR_SHIFT);
    eval 'sub SUN4C_PGDIR_SIZE () {(1 <<  &SUN4C_PGDIR_SHIFT);}' unless defined(&SUN4C_PGDIR_SIZE);
    eval 'sub SUN4C_PGDIR_MASK () {(~( &SUN4C_PGDIR_SIZE-1));}' unless defined(&SUN4C_PGDIR_MASK);
    eval 'sub SUN4C_PGDIR_ALIGN {
        local($addr) = @_;
	    eval q(((($addr)+ &SUN4C_PGDIR_SIZE-1) &SUN4C_PGDIR_MASK));
    }' unless defined(&SUN4C_PGDIR_ALIGN);
    eval 'sub SUN4C_REAL_PGDIR_SHIFT () {18;}' unless defined(&SUN4C_REAL_PGDIR_SHIFT);
    eval 'sub SUN4C_REAL_PGDIR_SIZE () {(1 <<  &SUN4C_REAL_PGDIR_SHIFT);}' unless defined(&SUN4C_REAL_PGDIR_SIZE);
    eval 'sub SUN4C_REAL_PGDIR_MASK () {(~( &SUN4C_REAL_PGDIR_SIZE-1));}' unless defined(&SUN4C_REAL_PGDIR_MASK);
    eval 'sub SUN4C_REAL_PGDIR_ALIGN {
        local($addr) = @_;
	    eval q(((($addr)+ &SUN4C_REAL_PGDIR_SIZE-1) &SUN4C_REAL_PGDIR_MASK));
    }' unless defined(&SUN4C_REAL_PGDIR_ALIGN);
    eval 'sub SUN4C_PFN_MASK () {0xffff;}' unless defined(&SUN4C_PFN_MASK);
    eval 'sub SUN4C_MAX_SEGMAPS () {256;}' unless defined(&SUN4C_MAX_SEGMAPS);
    eval 'sub SUN4C_MAX_CONTEXTS () {16;}' unless defined(&SUN4C_MAX_CONTEXTS);
    eval 'sub SUN4C_PTRS_PER_PTE () {1024;}' unless defined(&SUN4C_PTRS_PER_PTE);
    eval 'sub SUN4C_PTRS_PER_PMD () {1;}' unless defined(&SUN4C_PTRS_PER_PMD);
    eval 'sub SUN4C_PTRS_PER_PGD () {1024;}' unless defined(&SUN4C_PTRS_PER_PGD);
    eval 'sub _SUN4C_PAGE_VALID () {0x80000000;}' unless defined(&_SUN4C_PAGE_VALID);
    eval 'sub _SUN4C_PAGE_SILENT_READ () {0x80000000;}' unless defined(&_SUN4C_PAGE_SILENT_READ);
    eval 'sub _SUN4C_PAGE_DIRTY () {0x40000000;}' unless defined(&_SUN4C_PAGE_DIRTY);
    eval 'sub _SUN4C_PAGE_SILENT_WRITE () {0x40000000;}' unless defined(&_SUN4C_PAGE_SILENT_WRITE);
    eval 'sub _SUN4C_PAGE_PRIV () {0x20000000;}' unless defined(&_SUN4C_PAGE_PRIV);
    eval 'sub _SUN4C_PAGE_NOCACHE () {0x10000000;}' unless defined(&_SUN4C_PAGE_NOCACHE);
    eval 'sub _SUN4C_PAGE_PRESENT () {0x8000000;}' unless defined(&_SUN4C_PAGE_PRESENT);
    eval 'sub _SUN4C_PAGE_IO () {0x4000000;}' unless defined(&_SUN4C_PAGE_IO);
    eval 'sub _SUN4C_PAGE_READ () {0x800000;}' unless defined(&_SUN4C_PAGE_READ);
    eval 'sub _SUN4C_PAGE_WRITE () {0x400000;}' unless defined(&_SUN4C_PAGE_WRITE);
    eval 'sub _SUN4C_PAGE_ACCESSED () {0x200000;}' unless defined(&_SUN4C_PAGE_ACCESSED);
    eval 'sub _SUN4C_PAGE_MODIFIED () {0x100000;}' unless defined(&_SUN4C_PAGE_MODIFIED);
    eval 'sub _SUN4C_READABLE () {( &_SUN4C_PAGE_READ| &_SUN4C_PAGE_SILENT_READ|  &_SUN4C_PAGE_ACCESSED);}' unless defined(&_SUN4C_READABLE);
    eval 'sub _SUN4C_WRITEABLE () {( &_SUN4C_PAGE_WRITE| &_SUN4C_PAGE_SILENT_WRITE|  &_SUN4C_PAGE_MODIFIED);}' unless defined(&_SUN4C_WRITEABLE);
    eval 'sub _SUN4C_PAGE_CHG_MASK () {(0xffff| &_SUN4C_PAGE_ACCESSED| &_SUN4C_PAGE_MODIFIED);}' unless defined(&_SUN4C_PAGE_CHG_MASK);
    eval 'sub SUN4C_PAGE_NONE () { &__pgprot( &_SUN4C_PAGE_PRESENT);}' unless defined(&SUN4C_PAGE_NONE);
    eval 'sub SUN4C_PAGE_SHARED () { &__pgprot( &_SUN4C_PAGE_PRESENT| &_SUN4C_READABLE|  &_SUN4C_PAGE_WRITE);}' unless defined(&SUN4C_PAGE_SHARED);
    eval 'sub SUN4C_PAGE_COPY () { &__pgprot( &_SUN4C_PAGE_PRESENT| &_SUN4C_READABLE);}' unless defined(&SUN4C_PAGE_COPY);
    eval 'sub SUN4C_PAGE_READONLY () { &__pgprot( &_SUN4C_PAGE_PRESENT| &_SUN4C_READABLE);}' unless defined(&SUN4C_PAGE_READONLY);
    eval 'sub SUN4C_PAGE_KERNEL () { &__pgprot( &_SUN4C_READABLE| &_SUN4C_WRITEABLE|  &_SUN4C_PAGE_DIRTY| &_SUN4C_PAGE_PRIV);}' unless defined(&SUN4C_PAGE_KERNEL);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub sun4c_get_synchronous_error {
	    local($void) = @_;
    	    eval q({ my $sync_err;  &__asm__  &__volatile__(\\"lda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( $sync_err) : \\"r\\" ( &AC_SYNC_ERR), \\"i\\" ( &ASI_CONTROL));  $sync_err; });
	}' unless defined(&sun4c_get_synchronous_error);
	eval 'sub sun4c_get_synchronous_address {
	    local($void) = @_;
    	    eval q({ my $sync_addr;  &__asm__  &__volatile__(\\"lda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( $sync_addr) : \\"r\\" ( &AC_SYNC_VA), \\"i\\" ( &ASI_CONTROL));  $sync_addr; });
	}' unless defined(&sun4c_get_synchronous_address);
	eval 'sub sun4c_put_segmap {
	    local($addr,$entry) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"\\\\n\\\\tstba %1, [%0] %2; nop; nop; nop;\\\\n\\\\t\\" : : \\"r\\" ($addr), \\"r\\" ($entry), \\"i\\" ( &ASI_SEGMAP) : \\"memory\\"); });
	}' unless defined(&sun4c_put_segmap);
	eval 'sub sun4c_get_pte {
	    local($addr) = @_;
    	    eval q({  &register my $entry;  &__asm__  &__volatile__(\\"\\\\n\\\\tlda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( $entry) : \\"r\\" ($addr), \\"i\\" ( &ASI_PTE));  $entry; });
	}' unless defined(&sun4c_get_pte);
	eval 'sub sun4c_put_pte {
	    local($addr,$entry) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"\\\\n\\\\tsta %1, [%0] %2; nop; nop; nop;\\\\n\\\\t\\" : : \\"r\\" ($addr), \\"r\\" (($entry & ~( &_SUN4C_PAGE_PRESENT))), \\"i\\" ( &ASI_PTE) : \\"memory\\"); });
	}' unless defined(&sun4c_put_pte);
	eval 'sub sun4c_get_context {
	    local($void) = @_;
    	    eval q({  &register \'int\'  &ctx;  &__asm__  &__volatile__(\\"\\\\n\\\\tlduba [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( &ctx) : \\"r\\" ( &AC_CONTEXT), \\"i\\" ( &ASI_CONTROL));  &ctx; });
	}' unless defined(&sun4c_get_context);
	eval 'sub sun4c_set_context {
	    local($ctx) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"\\\\n\\\\tstba %0, [%1] %2; nop; nop; nop;\\\\n\\\\t\\" : : \\"r\\" ($ctx), \\"r\\" ( &AC_CONTEXT), \\"i\\" ( &ASI_CONTROL) : \\"memory\\"); $ctx; });
	}' unless defined(&sun4c_set_context);
    }
}
1;
