require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_UACCESS_H)) {
    eval 'sub _ASM_UACCESS_H () {1;}' unless defined(&_ASM_UACCESS_H);
    if(defined(&__KERNEL__)) {
	require 'linux/sched.ph';
	require 'linux/string.ph';
	require 'asm/vac-ops.ph';
	require 'asm/a.out.ph';
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub KERNEL_DS () {(( &mm_segment_t) { 0});}' unless defined(&KERNEL_DS);
	eval 'sub USER_DS () {(( &mm_segment_t) { -1});}' unless defined(&USER_DS);
	eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
	eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
	eval 'sub get_ds () {
	    eval q(( &KERNEL_DS));
	}' unless defined(&get_ds);
	eval 'sub get_fs () {
	    eval q(( ($current->{thread}->{current_ds})));
	}' unless defined(&get_fs);
	eval 'sub set_fs {
	    local($val) = @_;
    	    eval q((( ($current->{thread}->{current_ds})) = ($val)));
	}' unless defined(&set_fs);
	eval 'sub segment_eq {
	    local($a,$b) = @_;
    	    eval q((($a). &seg == ($b). &seg));
	}' unless defined(&segment_eq);
	eval 'sub __user_ok {
	    local($addr,$size) = @_;
    	    eval q((($addr) <  &STACK_TOP));
	}' unless defined(&__user_ok);
	eval 'sub __kernel_ok () {( &segment_eq( &get_fs(),  &KERNEL_DS));}' unless defined(&__kernel_ok);
	eval 'sub __access_ok {
	    local($addr,$size) = @_;
    	    eval q(( &__user_ok(($addr) &  &get_fs(). &seg,($size))));
	}' unless defined(&__access_ok);
	eval 'sub access_ok {
	    local($type,$addr,$size) = @_;
    	    eval q( &__access_ok(($addr),($size)));
	}' unless defined(&access_ok);
1;
